searchNodes=[{"doc":"Entry point for interacting with pages. Pages are built around Pages.Driver.t/0 structs. Drivers hold state about the current connection, implement @behavior Pages.Driver and must implement the String.Chars protocol to transform themselves into HTML. Available drivers Pages.Driver.Conn.t/0 - Given a Plug.Conn.t/0 , this driver will be used. Pages.Driver.LiveView.t/0 - Given a Plug.Conn.t/0 with inner data that appears as if a Phoenix.LiveView is configured, this driver will be used.","ref":"Pages.html","title":"Pages","type":"module"},{"doc":"Clears out any params set via Phoenix.LiveViewTest.put_connect_params/2","ref":"Pages.html#clear_connect_params/1","title":"Pages.clear_connect_params/1","type":"function"},{"doc":"","ref":"Pages.html#click/2","title":"Pages.click/2","type":"function"},{"doc":"","ref":"Pages.html#click/3","title":"Pages.click/3","type":"function"},{"doc":"Simulates clicking on an element at selector with title title . Set the method param to :post to click on a link that has data-method=post .","ref":"Pages.html#click/4","title":"Pages.click/4","type":"function"},{"doc":"Instantiates a new page.","ref":"Pages.html#new/1","title":"Pages.new/1","type":"function"},{"doc":"Render a change to the element at selector with the value value . See Phoenix.LiveViewTest.render_change/2 for a description of the value field.","ref":"Pages.html#render_change/3","title":"Pages.render_change/3","type":"function"},{"doc":"Sends a hook event to the live view. Arguments name decription page The current page struct. event The event name to send to handle_event . value_attrs A map of params to send to handle_event . opts An optional keyword list of options. Options name description target The selector of an embedded live componont to receive the event. Example: #sub-module See Phoenix.LiveViewTest.render_hook/3 for more information.","ref":"Pages.html#render_hook/4","title":"Pages.render_hook/4","type":"function"},{"doc":"Performs an upload of a file input and renders the result. See Phoenix.LiveViewTest.file_input/4 for a description of the upload field.","ref":"Pages.html#render_upload/4","title":"Pages.render_upload/4","type":"function"},{"doc":"Re-renders the page.","ref":"Pages.html#rerender/1","title":"Pages.rerender/1","type":"function"},{"doc":"Submits a form without specifying any attributes. This function will submit any values currently set in the form HTML.","ref":"Pages.html#submit_form/2","title":"Pages.submit_form/2","type":"function"},{"doc":"Fills in a form with attributes and submits it. Hidden parameters can by send by including a fifth enumerable. Arguments name decription page The current page struct. selector A CSS selector matching the form. schema An atom representing the schema of the form. Attributes will be nested under this key when submitted. See Schema . attrs A map of attributes to send. hidden_attrs An optional map or keyword of hidden values to include. Schema This atom determines the key under which attrs will be nested when sent to the server, and corresponds to the atom which an t:Ecto.Changeset.t/0 serializes to, or the value of :as passed to Phoenix.HTML.Form.form_for/4 . Notes When used with LiveView, this will trigger phx-submit with the specified attributes, and handles phx-trigger-action if present.","ref":"Pages.html#submit_form/4","title":"Pages.submit_form/4","type":"function"},{"doc":"See Pages.submit_form/4 for more information.","ref":"Pages.html#submit_form/5","title":"Pages.submit_form/5","type":"function"},{"doc":"Fills in a form with attributes without submitting it. Arguments See submit_form/4 for a full description of arguments. Notes When used with LiveView, this will trigger phx-change with the specified attributes, and handles phx-trigger-action if present.","ref":"Pages.html#update_form/4","title":"Pages.update_form/4","type":"function"},{"doc":"Visits path .","ref":"Pages.html#visit/2","title":"Pages.visit/2","type":"function"},{"doc":"Finds a phoenix component with an id matching child_id , and passes it to the given function. This is helpful when a site implements stateful LiveView components, and messages should be directed to a process other than the parent LiveView pid. Examples Pages . with_child_component ( page , &quot;chat-component&quot; , fn child -&gt; Pages . submit_form ( child , [ test_role : &quot;new-chat-message&quot; ] , :chat_message , contents : &quot;Hi there!&quot; ) end )","ref":"Pages.html#with_child_component/3","title":"Pages.with_child_component/3","type":"function"},{"doc":"","ref":"Pages.html#t:attrs_t/0","title":"Pages.attrs_t/0","type":"type"},{"doc":"","ref":"Pages.html#t:http_method/0","title":"Pages.http_method/0","type":"type"},{"doc":"","ref":"Pages.html#t:live_view_upload/0","title":"Pages.live_view_upload/0","type":"type"},{"doc":"","ref":"Pages.html#t:page_type_t/0","title":"Pages.page_type_t/0","type":"type"},{"doc":"","ref":"Pages.html#t:text_filter/0","title":"Pages.text_filter/0","type":"type"},{"doc":"Defines types and behaviours that page drivers must implement.","ref":"Pages.Driver.html","title":"Pages.Driver","type":"behaviour"},{"doc":"Click an element within a page. Implementation for Pages.click/4 .","ref":"Pages.Driver.html#c:click/4","title":"Pages.Driver.click/4","type":"callback"},{"doc":"Render a change. Implementation for Pages.render_change/3 .","ref":"Pages.Driver.html#c:render_change/3","title":"Pages.Driver.render_change/3","type":"callback"},{"doc":"Render a hook event. Implementation for Pages.render_hook/3 .","ref":"Pages.Driver.html#c:render_hook/4","title":"Pages.Driver.render_hook/4","type":"callback"},{"doc":"Render a file upload. Implementation for Pages.render_upload/4 .","ref":"Pages.Driver.html#c:render_upload/4","title":"Pages.Driver.render_upload/4","type":"callback"},{"doc":"Re-renders the page. Implementation for Pages.rerender/1 .","ref":"Pages.Driver.html#c:rerender/1","title":"Pages.Driver.rerender/1","type":"callback"},{"doc":"Submit a form targeted by the given selector. Implementation for Pages.submit_form/2 .","ref":"Pages.Driver.html#c:submit_form/2","title":"Pages.Driver.submit_form/2","type":"callback"},{"doc":"Fills in a form with the attributes and submits it. Implementation for Pages.submit_form/4 .","ref":"Pages.Driver.html#c:submit_form/4","title":"Pages.Driver.submit_form/4","type":"callback"},{"doc":"Fills in a form with the attributes and submits it. Implementation for Pages.submit_form/5 .","ref":"Pages.Driver.html#c:submit_form/5","title":"Pages.Driver.submit_form/5","type":"callback"},{"doc":"Fills in a form with the attributes without submitting it. Implementation for Pages.update_form/4 .","ref":"Pages.Driver.html#c:update_form/4","title":"Pages.Driver.update_form/4","type":"callback"},{"doc":"Navigate directly to a page. Implementation for Pages.visit/2 .","ref":"Pages.Driver.html#c:visit/2","title":"Pages.Driver.visit/2","type":"callback"},{"doc":"Target a child component for actions. Implementation for Pages.with_child_component/3 .","ref":"Pages.Driver.html#c:with_child_component/3","title":"Pages.Driver.with_child_component/3","type":"callback"},{"doc":"","ref":"Pages.Driver.html#t:t/0","title":"Pages.Driver.t/0","type":"type"},{"doc":"A page driver for interacting with Phoenix controllers.","ref":"Pages.Driver.Conn.html","title":"Pages.Driver.Conn","type":"module"},{"doc":"Simulates clicking on an element at selector with title title .","ref":"Pages.Driver.Conn.html#click/4","title":"Pages.Driver.Conn.click/4","type":"function"},{"doc":"","ref":"Pages.Driver.Conn.html#new/1","title":"Pages.Driver.Conn.new/1","type":"function"},{"doc":"","ref":"Pages.Driver.Conn.html#t:t/0","title":"Pages.Driver.Conn.t/0","type":"type"},{"doc":"A page driver for interacting with Phoenix.LiveView pages.","ref":"Pages.Driver.LiveView.html","title":"Pages.Driver.LiveView","type":"module"},{"doc":"Called from Pages.click/4 when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#click/4","title":"Pages.Driver.LiveView.click/4","type":"function"},{"doc":"Perform a live redirect to the given path. This is not implemented in Pages due to its specificity to LiveView and LiveViewTest.","ref":"Pages.Driver.LiveView.html#live_redirect/2","title":"Pages.Driver.LiveView.live_redirect/2","type":"function"},{"doc":"","ref":"Pages.Driver.LiveView.html#new/1","title":"Pages.Driver.LiveView.new/1","type":"function"},{"doc":"","ref":"Pages.Driver.LiveView.html#new/2","title":"Pages.Driver.LiveView.new/2","type":"function"},{"doc":"Called from Paged.render_change/3 when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#render_change/3","title":"Pages.Driver.LiveView.render_change/3","type":"function"},{"doc":"Called from Paged.render_hook/3 when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#render_hook/4","title":"Pages.Driver.LiveView.render_hook/4","type":"function"},{"doc":"Called from Paged.render_upload/4 when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#render_upload/4","title":"Pages.Driver.LiveView.render_upload/4","type":"function"},{"doc":"Called from Pages.rerender/1 when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#rerender/1","title":"Pages.Driver.LiveView.rerender/1","type":"function"},{"doc":"Called from Pages.submit_form/2 when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#submit_form/2","title":"Pages.Driver.LiveView.submit_form/2","type":"function"},{"doc":"Called from Pages.submit_form/4 and Pages.submit_form/5 when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#submit_form/5","title":"Pages.Driver.LiveView.submit_form/5","type":"function"},{"doc":"Called from Pages.update_form/4 when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#update_form/4","title":"Pages.Driver.LiveView.update_form/4","type":"function"},{"doc":"Initialize a live with the given path. This is called from Pages.visit/2 when the conn indicates that the pages is a LiveView, and should only be called directly if the parent function does not work for some reason.","ref":"Pages.Driver.LiveView.html#visit/2","title":"Pages.Driver.LiveView.visit/2","type":"function"},{"doc":"Find a child component, and pass it as a new Page into the given function. Rerenders the top-level page upon completion. See Pages.with_child_component/3 .","ref":"Pages.Driver.LiveView.html#with_child_component/3","title":"Pages.Driver.LiveView.with_child_component/3","type":"function"},{"doc":"","ref":"Pages.Driver.LiveView.html#t:t/0","title":"Pages.Driver.LiveView.t/0","type":"type"},{"doc":"Errors that are specifically raised from page drivers.","ref":"Pages.Error.html","title":"Pages.Error","type":"exception"},{"doc":"An Elixir implementation of the Page Object pattern for interacting with websites. This library can be used to facilitate testing of Phoenix controllers and LiveView pages in the context of ExUnit, and may be used as the basis of other drivers. Note : prior to the release of 1.0.0 , minor releases of this library may include breaking changes. While new, this library is undergoing rapid development. A goal is to reach a stable API and a 1.0.0 release as soon as possible. See the API reference for more info, specifically the docs for the Pages module.","ref":"readme.html","title":"Pages","type":"extras"},{"doc":"def deps do [ { :pages , &quot;~&gt; 0.10&quot; , only : :test } ] end","ref":"readme.html#installation","title":"Pages - Installation","type":"extras"},{"doc":"The typical usage is to create a module for each page of your web app, with functions for each action that a user can take on that page, and then to call those functions in a test. Note that in this example, Web and Test are top-level modules in the app that's being tested. defmodule Web.HomeLiveTest do use Test.ConnCase , async : true test &quot;has login button&quot; , %{ conn : conn } do conn |&gt; Pages . new ( ) |&gt; Test.Pages.HomePage . assert_here ( ) |&gt; Test.Pages.HomePage . click_login_link ( ) |&gt; Test.Pages.LoginPage . assert_here ( ) end end Here is the definition of the HomePage module that's used in the test above. This test uses assert_eq/3 from the Moar library, and find/2 &amp; attr/2 from the HtmlQuery library. defmodule Test.Pages.HomePage do import Moar.Assertions alias HtmlQuery , as : Hq @spec assert_here ( Pages.Driver . t ( ) ) :: Pages.Driver . t ( ) def assert_here ( % Pages.Driver.LiveView { } = page ) do page |&gt; Hq . find ( &quot;[data-page]&quot; ) |&gt; Hq . attr ( &quot;data-page&quot; ) |&gt; assert_eq ( &quot;home&quot; , returning : page ) end @spec click_login_link ( Pages.Driver . t ( ) ) :: Pages.Driver . t ( ) def click_login_link ( page ) , do : page |&gt; Pages . click ( &quot;Log In&quot; , test_role : &quot;login-link&quot; ) @spec visit ( Pages.Driver . t ( ) ) :: Pages.Driver . t ( ) def visit ( page ) , do : page |&gt; Pages . visit ( &quot;/&quot; ) end A page module that you define can work with either a controller-based page or a LiveView-based page, and a test can test workflows that use both controllers and LiveViews.","ref":"readme.html#usage","title":"Pages - Usage","type":"extras"},{"doc":"This library uses functions from Phoenix.ConnTest and from Phoenix.LiveViewTest to simulate a user clicking around and therefore can't test any Javascript functionality. To fix this, a driver for browser-based testing via Wallaby or Playwright Elixir would be needed, but one does not yet exist. The upside is that Pages-based tests are extremely fast.","ref":"readme.html#under-the-hood","title":"Pages - Under the hood","type":"extras"},{"doc":"Copyright 2022 synchronal.dev Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]